package main

import (
	"bufio"
	"io"
	"os"
	"path/filepath"
	"regexp"
	"strconv"
	"strings"

	"gitlab.com/gitlab-org/security-products/analyzers/common/issue"
)

const toolID = "security_code_scan"

var regexpSecWarning *regexp.Regexp

const (
	indexSourceFile = iota + 1
	indexLine
	indexColumn
	indexRuleID
	indexMessage
	indexProjectFile
)

const secCodeScanURL = "https://security-code-scan.github.io/"

func init() {
	regexpSecWarning = regexp.MustCompile(`\A([^(]+)\((\d+),(\d+)\): warning (SCS\d+): ([^[]+) \[([^]]+)\]`)
}

func convert(reader io.Reader, prependPath string) ([]issue.Issue, error) {

	// HACK: extract root path from environment variables
	root := os.Getenv("ANALYZER_TARGET_DIR")
	if root == "" {
		root = os.Getenv("CI_PROJECT_DIR")
	}

	// Scan and parse build output
	scanner := bufio.NewScanner(reader)
	issues := []issue.Issue{}
	for scanner.Scan() {
		line := scanner.Text()

		if strings.Index(line, "Build") == 0 {
			// Ignore what follows "Build..."
			break
		}

		if match(line) {
			warn, err := parse(line)
			if err != nil {
				return nil, err
			}
			r := Result{
				SecWarning:  warn,
				PrependPath: prependPath,
				Root:        root,
			}
			issues = append(issues, issue.Issue{
				Category:   issue.CategorySast,
				Tool:       toolID,
				Name:       r.Message,
				Message:    r.Message,
				CompareKey: r.CompareKey(),
				Location: issue.Location{
					File:      r.Filepath(),
					LineStart: r.Line,
				},
				Identifiers: []issue.Identifier{
					r.Identifier(),
				},
			})
		}
	}
	return issues, nil
}

// match tells whether the given string is a SCS warning generated during the build.
func match(s string) bool {
	return strings.Contains(s, "warning SCS")
}

// parse extracts a SecWarning from a build warning.
func parse(s string) (*SecWarning, error) {
	m := regexpSecWarning.FindStringSubmatch(s)

	// convert line number
	line, err := strconv.Atoi(m[indexLine])
	if err != nil {
		return nil, err
	}

	// convert column
	col, err := strconv.Atoi(m[indexColumn])
	if err != nil {
		return nil, err
	}

	return &SecWarning{
		SourceFile:  m[indexSourceFile],
		Line:        line,
		Column:      col,
		RuleID:      m[indexRuleID],
		Message:     m[indexMessage],
		ProjectFile: m[indexProjectFile],
	}, nil
}

// Result describes a result with a relative path.
type Result struct {
	*SecWarning
	PrependPath string
	Root        string
}

// Filepath returns the relative path of the affected file.
func (r Result) Filepath() string {
	// Source file is relative to the directory that contains the project file.
	// Ignore PrependPath since it's already in the path of the project file.
	root := strings.TrimSuffix(r.Root, "/") + "/" // Make sure there's a trailing slash
	dir := filepath.Dir(strings.TrimPrefix(r.ProjectFile, root))
	return filepath.Join(dir, r.SourceFile)
}

// CompareKey returns a string used to establish whether two issues are the same.
func (r Result) CompareKey() string {
	return strings.Join([]string{r.Filepath(), strconv.Itoa(r.Line), r.RuleID}, ":")
}

// Identifier returns the SCS rule as a normalized identifier.
func (r Result) Identifier() issue.Identifier {
	return issue.Identifier{
		Type:  "security_code_scan_rule_id",
		Name:  r.RuleID,
		Value: r.RuleID,
		URL:   secCodeScanURL + "#" + r.RuleID,
	}
}

// SecWarning is a warning generated by SCS during the build.
type SecWarning struct {
	SourceFile  string
	Line        int
	Column      int
	ProjectFile string
	RuleID      string
	Message     string
}
